Codeforces 652C Foe Pairs 【dp】

C. Foe Pairs
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given a permutation p of length n. Also you are given m foe pairs (ai, bi) (1 ≤ ai, bi ≤ n, ai ≠ bi).

Your task is to count the number of different intervals (x, y) (1 ≤ x ≤ y ≤ n) that do not contain any foe pairs. So you shouldn't count intervals (x, y) that contain at least one foe pair in it (the positions and order of the values from the foe pair are not important).

Consider some example: p = [1, 3, 2, 4] and foe pairs are {(3, 2), (4, 2)}. The interval (1, 3) is incorrect because it contains a foe pair (3, 2). The interval (1, 4) is also incorrect because it contains two foe pairs (3, 2) and (4, 2). But the interval (1, 2) is correct because it doesn't contain any foe pair.
Input

The first line contains two integers n and m (1 ≤ n, m ≤ 3·105) — the length of the permutation p and the number of foe pairs.

The second line contains n distinct integers pi (1 ≤ pi ≤ n) — the elements of the permutation p.

Each of the next m lines contains two integers (ai, bi) (1 ≤ ai, bi ≤ n, ai ≠ bi) — the i-th foe pair. Note a foe pair can appear multiple times in the given list.
Output

Print the only integer c — the number of different intervals (x, y) that does not contain any foe pairs.

Note that the answer can be too large, so you should use 64-bit integer type to store it. In C++ you can use the long long integer type and in Java you can use long integer type.
Examples
Input

4 2
1 3 2 4
3 2
2 4

Output

5

Input

9 5
9 7 2 3 1 4 6 5 8
1 6
4 5
2 7
7 2
2 7

Output

20

Note

In the first example the intervals from the answer are (1, 1), (1, 2), (2, 2), (3, 3) and (4, 4).

题意:给你1-n的一个排列和m组数对,问有多少区间不包含任意一个数对。

思路:倒着做,用总方案数去掉那些不符合的就是结果。先预处理数对的区间[l[i],r[i]] (1<=i<=m),考虑以第i个数开始的区间,我们需要的信息的是min(r[j]) l[j]>=i,这样不合法的区间数有n−dp[i]+1。
用dp[i]=min(r[j]) l[j]>=i,这样我们到着做一遍就把dp全求出来了。
dp[i]表示i到右边最近一个与它可构成数对的那个数的位置。

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N=3e5+5;
int f[N],pos[N];
int main()
{
    int n,m; scanf("%d%d",&n,&m);
    int u,v;
    for(int i=1;i<=n;i++){
        scanf("%d",&v);
        pos[v]=i;f[i]=n+1;
    }
    ll ans=1ll*n*(n-1)/2+n;
    for(int i=0;i<m;i++){
        scanf("%d%d",&u,&v);
        if(pos[u]>pos[v])swap(u,v);
        f[pos[u]]=min(f[pos[u]],pos[v]);
    }
    for(int i=n-1;i>=1;i--)f[i]=min(f[i],f[i+1]);
    for(int i=1;i<n;i++){
        ans-=(n-f[i]+1);
    }
    cout<<ans;
    return 0;
}
原文地址:https://www.cnblogs.com/01world/p/5651229.html